// JavaScript-Programm nach dem Programmablaufplan fr die maschinelle Berechnung
// der vom Arbeitslohn einzubehaltenden Lohnsteuer, des Solidrttszuschlags und
// der Mastabsteuer fr die Kirchenlohnsteuer 2007
// Version 10.2.2007
// Der Programmablaufplan findet sich auf den Internetseiten des BMF zum
// Herunterladen unter http://www.bundesfinanzministerium.de/lang_de/DE/Aktuelles/BMF__Schreiben/Veroffentlichungen__zu__Steuerarten/lohnsteuer/055,templateId=raw,property=publicationFile.pdf



public class lohnst_pap2007 {   // Interne Felder, PAP 2007, S. 5ff.

    String s;
    double ALTE;
    double ANP;
    double ANTEIL1;
    double ANTEIL2;
    double BMG;
    double DIFF;
    double EFA;
    double FVB;
    double FVBZ;
    double HFVB;
    int J;
    double JBMG;
    double JW;
    int K;
    int KENNZ;
    double KFB;
    int KZTAB;
    double LSTJAHR;
    double LST1;
    double LST2;
    double LST3;
    double MIST;
    double RE4LZZ;
    double RE4LZZV;
    double RW;
    double SAP;
    double SOLZFREI;
    double SOLZJ;
    double SOLZMIN;
    double ST;
    double ST1;
    double ST2;
    // Definition TAB1 usw. s. unten
    double VBEZB;
    double VHB;
    double VSP;
    double VSPN;
    double VSP1;
    double VSP2;
    double VSPKURZ;
    double VSPMAX1;
    double VSPMAX2;
    double VSPO;
    double VSPREST;
    double VSPVOR;
    double X;
    double Y;
    double ZRE4;
    double ZRE4VP;
    double ZRE4VP1;
    double ZTABFB;
    double ZVBEZ;
    double ZVE;
    double ZX;
    double ZZX;
    double HOCH;
    double VERGL;

    double TAB1[] = {0, 0.4, 0.384, 0.368, 0.352, 0.336, 0.32, 0.304, 0.288, 0.272, 0.256, 0.24, 0.224, 0.208, 0.192, 0.176, 0.16, 0.152, 0.144, 0.136, 0.128, 0.12, 0.112, 0.104, 0.096, 0.088, 0.08, 0.072, 0.064, 0.056, 0.048, 0.04, 0.032, 0.024, 0.016, 0.008, 0};
   int TAB2[] = {0, 3000, 2880, 2760, 2640, 2520, 2400, 2280, 2160, 2040, 1920, 1800, 1680, 1560, 1440, 1320, 1200, 1140, 1080, 1020, 960, 900, 840, 780, 720, 660, 600, 540, 480, 420, 360, 300, 240, 180, 120, 60, 0};
    int TAB3[]= {0, 900, 864, 828, 792, 756, 720, 684, 648, 612, 576, 540, 504, 468, 432, 396, 360, 342, 324, 306, 288, 270, 252, 234, 216, 198, 180, 162, 144, 126, 108, 90, 72, 54, 36, 18, 0};
    //TAB4 = TAB1
    int TAB5[] = {0,1900, 1824, 1748, 1672, 1596, 1520, 1444, 1368, 1292, 1216, 1140, 1064, 988, 912, 836, 760, 722, 684, 646, 608, 570, 532, 494, 456, 418, 380, 342, 304, 266, 228, 190, 152, 114, 76, 38, 0};

    // --- Eingangsparameter  PAP 2007, S. 3FF.

    int AJAHR;
    int ALTER1;  //Unntige Konstante, da Alter mit AJAHR bestimmt ist
    double HINZUR;
    double JFREIB;
    double JHINZU;
    double JRE4;
    double JVBEZ;
    int KRV;
    int LZZ;
    int R;
    double RE4;
    double SONSTB;
    double STERBE;
    int STKL;
    double VBEZ;
    double VBEZM;
    double VBEZS;
    double VBS;
    int VJAHR;
    double VKAPA;
    double VMT;
    double WFUNDF;
    double ZKF;
    int ZMVB;

    // --- Ausgangsparameter, PAP 2007, S. 5

    double BK;
    double BKS;
    double BKV;
    double LSTLZZ;
    double SOLZLZZ;
    double SOLZS;
    double SOLZV;
    double STS;
    double STV;

    // --- EIGENE PARAMETER
    double lstges;
    double soliges;
    double kistges;


  public lohnst_pap2007(int i,int j,double d1,double d2,double d3,
           double d4,double d5,int k,int l,int m,double d6,double d7,
           double d8,int n,double d9,double d10,double d11,double d12,int o,
           double d13,double d14,double d15,double d16,int p) {

   // Parameter-Eingabe
    AJAHR = i;
    ALTER1 = j;
    HINZUR = d1;
    JFREIB = d2;
    JHINZU = d3;
    JRE4 = d4;
    JVBEZ = d5;
    KRV = k;
    LZZ = l;
    R = m;
    RE4 = d6;
    SONSTB = d7;
    STERBE = d8;
    STKL = n;
    VBEZ = d9;
    VBEZM = d10;
    VBEZS = d11;
    VBS = d12;
    VJAHR = o;
    VKAPA = d13;
    VMT = d14;
    WFUNDF = d15;
    ZKF = d16;
    ZMVB = p;

    //Programmablaufplan 2007, Steuerung S.9
    MRE4LZZ();
    KENNZ = 0;
    RE4LZZ = RE4 - FVB - ALTE - WFUNDF + HINZUR;
    RE4LZZV = RE4 - FVB - ALTE;
    MRE4();
    MZTABFB();
    MLSTJAHR();
    LSTJAHR = ST;
    JW = LSTJAHR * 100;
    UPANTEIL();
    LSTLZZ = ANTEIL1;
    if (ZKF > 0) {
       ZTABFB = ZTABFB + KFB;
       MLSTJAHR();
       JBMG = ST;
     }
     else
       JBMG = LSTJAHR;
    MSOLZ();
    MSONST();
    MVMT();
    lstges = LSTLZZ + STS + STV;
    soliges = SOLZLZZ + SOLZS + SOLZV;
    kistges = BK + BKS + BKV;

    s = "FVB: " + FVB/100 + " | ALTE: " + ALTE/100 + " | ZRE4: " + ZRE4 + " | ZTABFB: " + ZTABFB + " | VSP: " + VSP + " | STS: " + STS/100 + " | STV: " + STV/100;
  }

  public void MRE4LZZ() {
   //Freibetraege fuer Versorgungsbezuege, Altersentlastungsbetrag (39B Abs. 2, Satz 2 ESTG) PAP Seite 10

    if (VBEZ == 0) {
       FVBZ = 0;
       FVB = 0;
       }
     else {
       if (VJAHR < 2006)
          J = 1;
        else {
          if (VJAHR < 2040)
             J = VJAHR - 2004;
          else
             J = 36;
        }

       if (LZZ == 1) {
          if (STERBE + VKAPA > 0) {
             VBEZB = VBEZM * ZMVB + VBEZS;
             HFVB = TAB2[J] * 100;
             FVBZ = TAB3[J];
          }
            else {
             VBEZB = VBEZM * ZMVB + VBEZS;
             HFVB = TAB2[J] / 12 * ZMVB * 100;
             FVBZ = Math.ceil(TAB3[J] / 12 * ZMVB);
           }
         }
        else {
          VBEZB = VBEZM * 12 + VBEZS;
          HFVB = TAB2[J] * 100;
          FVBZ = TAB3[J];
       }
       FVB = Math.ceil(VBEZB * TAB1[J]*100)/100;
       if (FVB > HFVB)
          FVB = HFVB;
       JW = FVB;
       UPANTEIL();
       FVB = ANTEIL2;
    }

    if (ALTER1 == 0)
       ALTE = 0;

    else {
       if (AJAHR < 2006)
          K = 1;
       else {
          if (AJAHR < 2040)
             K = AJAHR - 2004;
          else
             K = 36;
      }

       BMG = RE4 - VBEZ;
       ALTE = Math.ceil(BMG * TAB1[K]);
       JW = TAB5[K] * 100;
       UPANTEIL();
       if (ALTE > ANTEIL2)
          ALTE = ANTEIL2;
   }
 }

 public void MRE4() {
 //massgeblicher Arbeitslohn fuer die Jahreslohnsteuer PAP Seite 12

    if (LZZ == 1) {
       ZRE4 = Math.floor(RE4LZZ) / 100;
       ZRE4VP = Math.floor(RE4LZZV) / 100;
       ZVBEZ = Math.floor(VBEZ - FVB) / 100;
    }
    if (LZZ == 2) {
       ZRE4 = Math.floor((RE4LZZ + 0.67) * 12)/100;
       ZRE4VP = Math.floor((RE4LZZV + 0.67) * 12)/100;
       ZVBEZ = Math.floor((VBEZ - FVB + 0.67) * 12)/100;
    }
    if (LZZ == 3) {
       ZRE4 = Math.floor((RE4LZZ + 0.89) * 360 / 7)/100;
       ZRE4VP = Math.floor((RE4LZZV + 0.89) * 360 / 7)/100;
       ZVBEZ = Math.floor((VBEZ - FVB + 0.89) * 360 / 7)/100;
    }
    if (LZZ == 4) {
       ZRE4 = Math.floor((RE4LZZ + 0.56) * 360)/100;
       ZRE4VP = Math.floor((RE4LZZV + 0.56) * 360)/100;
       ZVBEZ = Math.floor((VBEZ - FVB + 0.56) * 360)/100;
    }
    if (ZRE4 < 0)
        ZRE4 = 0;

    if (ZVBEZ <=0 || VBEZ<=0) //Abweichend vom PAP
        ZVBEZ = 0;
}

  public void MZTABFB() {
  //Ermittlung der festen Tabellenfreibetraege (ohne Vorsorgepauschale) PAP Seite 13

    ANP = 0;
    if (VBEZ > 0) {
       if (ZVBEZ < FVBZ)
          FVBZ = ZVBEZ;
    }
    if (STKL < 6) {
       if (ZVBEZ > 0) {
          if (ZVBEZ - FVBZ < 102)
             ANP = ZVBEZ - FVBZ;
            else
             ANP = 102;
       }
    }
    if (STKL < 6) {
       if (ZRE4 > ZVBEZ) {
          if (ZRE4 - ZVBEZ < 920)
             ANP = ANP + ZRE4 - ZVBEZ;
            else
             ANP = ANP + 920;
       }
    }

       KZTAB = 1;
   if (STKL == 1) {
       SAP = 36;
       KFB = ZKF * 5808;
    }
    if (STKL == 2) {
       EFA = 1308;
       SAP = 36;
       KFB = ZKF * 5808;
    }
    if (STKL == 3) {
       KZTAB = 2;
       SAP = 72;
       KFB = ZKF * 5808;
   }
    if (STKL == 4) {
       SAP = 36;
       KFB = ZKF * 2904;
    }
    if (STKL == 5)
       KFB = 0;

    if (STKL == 6)
       KFB = 0;

    ZTABFB = EFA + ANP + SAP + FVBZ;
 }


  public void MLSTJAHR() { //Ermittlung der Jahreslohnsteuer, PAP S. 14

    if (STKL < 5)
       UPEVP();
     else
       VSP = 0;

    ZVE = ZRE4 - ZTABFB - VSP;

    if (ZVE < 1) {
       ZVE = 0;
       X = 0;
     }
     else
       X = Math.floor(ZVE / KZTAB);  // auf Euro abrunden

     if (STKL < 5)
       uptab07();
     else
       MST5_6();
}

  public void UPEVP() {
  // Vorsorgepauschale (39B ABS. 2 SATZ 6 NR 3 ESTG)PAP SEITE 15

    if (KRV == 1)
         VSP1 = 0;
     else {
       if (ZRE4VP > 63000)
            ZRE4VP = 63000;
       VSP1 = 0.28 * ZRE4VP;
       VSP1 = VSP1 * 0.0995;
    }
    VSP2 = 0.11 * ZRE4VP;
    VHB = 1500 * KZTAB;
    if (VSP2 > VHB)
       VSP2 = VHB;
    VSPN = Math.ceil(VSP1 + VSP2);  //auf Euro aufrunden
    MVSP();
    if (VSPN > VSP)
       VSP = VSPN;
}

 public void MVSP() {
 //Vorsorgepauschale (39B ABS. 2 SATZ 6 NR 3 ESTG) Vergleichsberechnung
 //fuer Guenstigerpruefung PAP Seite 16

    if (KENNZ == 1)
       VSPO = ZRE4VP1 * 0.2;
     else
       VSPO = ZRE4VP * 0.2;

    VSPVOR = 3068 * KZTAB;
    VSPMAX1 = 1334 * KZTAB;
    VSPMAX2 = 667 * KZTAB;
    VSPKURZ = 1134 * KZTAB;
    if (KRV == 1) {
       if (VSPO > VSPKURZ)
          VSP = VSPKURZ;
        else
          VSP = Math.floor(VSPO);  // auf Euro abrunden
       }
    else
       UMVSP();
 }


  public void UMVSP() {  //Vorsorgepauschale, PAP 2007, S. 17

    if (KENNZ == 1)
       VSPVOR = VSPVOR - ZRE4VP1 * 0.16;
     else
       VSPVOR = VSPVOR - ZRE4VP * 0.16;

    if (VSPVOR < 0)
       VSPVOR = 0;

    if (VSPO > VSPVOR) {
       VSP = VSPVOR;
       VSPREST = VSPO - VSPVOR;

       if (VSPREST > VSPMAX1) {
          VSP = VSP + VSPMAX1;
          VSPREST = Math.ceil((VSPREST - VSPMAX1)*100) / 200; //auf Cent aufrunden
       if (VSPREST > VSPMAX2)
          VSP = Math.floor(VSP + VSPMAX2); //auf Euro abrunden
       else
          VSP = Math.floor(VSP + VSPREST); //auf Euro abrunden
        }
        else
            VSP = Math.floor(VSP + VSPREST); //auf Euro abrunden
     }
     else
         VSP = Math.floor(VSPO); // auf Euro abrunden
 }

    public void MST5_6() {
    // Lohnsteuer fuer die Steuerklassen V und VI ( 39B Abs. 2 Satz 8 ESTG) PAP Seite 18

    ZZX = X;
    if (ZZX > 25812) {
       ZX = 25812;
       UP5_6();
       if (ZZX > 200000) {
         ST = ST + (200000 - 25812) * 0.42;
         ST = Math.floor(ST + (ZZX - 200000) * 0.45);
       }
       else
         ST = Math.floor(ST + (ZZX - 25812) * 0.42);
     }
     else {
       ZX = ZZX;
       UP5_6();
       if (ZZX > 9144) {
          VERGL = ST;
          ZX = 9144;
          UP5_6();
          HOCH = Math.floor(ST + (ZZX - 9144) * 0.42);
          if (HOCH < VERGL)
             ST = HOCH;
           else
             ST = VERGL;
        }
     }
  }

  public void UP5_6() {
    X = ZX * 1.25;
    uptab07();
    ST1 = ST;
    X = ZX * 0.75;
    uptab07();
    ST2 = ST;
    DIFF = (ST1 - ST2) * 2;
    MIST = Math.floor(ZX * 0.15);
    if (MIST > DIFF)
       ST = MIST;
     else
       ST = DIFF;
 }

 public void MSOLZ() {   // SOLIDARITTSZUSCHLAG, PAP S. 19
    SOLZFREI = 972 * KZTAB;
    if (JBMG > SOLZFREI) {
       SOLZJ = JBMG * 5.5 / 100;
       SOLZMIN = (JBMG - SOLZFREI) * 20 / 100;
       if (SOLZMIN < SOLZJ)
          SOLZJ = SOLZMIN;
       JW = SOLZJ * 100;
       UPANTEIL();
       SOLZLZZ = ANTEIL1;
     }
     else
       SOLZLZZ = 0;

     if (R > 0){
       JW = JBMG * 100;
       UPANTEIL();
       BK = ANTEIL1;
       }
     else
       BK = 0;
    }


 public void UPANTEIL() {  // Anteil der Jahresbeitrge fr einen LZZ
                        // PAP 2007, S. 20
                        // ANTEIL1 abrunden, ANTEIL2 aufrunden
    if (LZZ == 1) {
       ANTEIL1 = JW;
       ANTEIL2 = JW;
    }
    if (LZZ == 2) {
       ANTEIL1 = Math.floor(JW / 12);
       ANTEIL2 = Math.ceil(JW / 12);
    }
    if (LZZ == 3) {
       ANTEIL1 = Math.floor(JW * 7 / 360);
       ANTEIL2 = Math.ceil(JW * 7 / 360);
    }
    if (LZZ == 4) {
       ANTEIL1 = Math.floor(JW / 360);
       ANTEIL2 = Math.ceil(JW / 360);
    }
  }

  public void MSONST() {  // Berechnung sonstiger Bezge, PAP 2007, S. 21
    if (SONSTB > 0) {
       LZZ = 1;
       VBEZ = JVBEZ;
       RE4 = JRE4;
       MRE4LZZ();
       MRE4LZZ2();
       MLSTJAHR();
       LST1 = ST * 100;
       VBEZ = JVBEZ + VBS;
       RE4 = JRE4 + SONSTB;
       VBEZS = VBEZS + STERBE;
       MRE4LZZ();
       MRE4LZZ2();
       MLSTJAHR();
       LST2 = ST * 100;
       STS = LST2 - LST1;
       // negativer SONTB nicht bercksichtigt
       SOLZS = Math.floor(STS * 5.5 / 100);
       if (R > 0)
          BKS = STS;
        else
          BKS = 0;
     }
    else {
       STS = 0;
       SOLZS = 0;
       BKS = 0;
    }
}

 public void MRE4LZZ2() {
     RE4LZZ = RE4 - FVB - ALTE - JFREIB + JHINZU;
     RE4LZZV = RE4 - FVB - ALTE;
     MRE4();
     MZTABFB();
}

public void MVMT() {  // Berechnung der Vergtung fr mehrjhrige Ttigkeit
                   // PAP 2007, S. 22
    if (VMT + VKAPA > 0) {
       LZZ = 1;
       VBEZ = JVBEZ + VBS;
       RE4 = JRE4 + SONSTB;
       MRE4LZZ();
       MRE4LZZ2();
       MLSTJAHR();
       LST1 = ST * 100;
       VMT = VMT + VKAPA;
       VBEZS = VBEZS + VKAPA;
       VBEZ = VBEZ + VKAPA;
       RE4 = JRE4 + SONSTB + VMT;
       MRE4LZZ();
       MRE4LZZ2();
       KENNZ = 1;
       ZRE4VP1 = ZRE4VP;
       MLSTJAHR();
       LST3 = ST * 100;
       VBEZ = VBEZ - VKAPA;
       VBEZS = VBEZS - VKAPA;
       RE4 = JRE4 + SONSTB;
       MRE4LZZ();
       if (RE4 - JFREIB + JHINZU < 0) {
          RE4 = RE4 - JFREIB + JHINZU;
          JFREIB = 0;
          JHINZU = 0;
          RE4 = (RE4 + VMT) / 5;
          MRE4LZZ2();
          MLSTJAHR();
          LST2 = ST * 100;
          STV = LST2 * 5;
        }
        else {
          RE4 = RE4 + VMT / 5;
          MRE4LZZ2();
          MLSTJAHR();
          LST2 = ST * 100;
          STV = (LST2 - LST1) * 5;
        }
       LST3 = LST3 - LST1;
       if (LST3 < STV)
          STV = LST3;
       SOLZV = Math.floor(STV * 5.5 / 100);
       if (R > 0)
          BKV = STV;
        else
          BKV = 0;
     }
     else {
       STV = 0;
       SOLZV = 0;
       BKV = 0;
    }
 }

 public void uptab07() {  //tarifliche Einkommensteuer, PAP 2007, S. 23
    if (X < 7665)
          ST = 0;
        else {
        if (X < 12740) {
           Y = (X - 7664) / 10000;
           RW = Y * 883.74;
           RW = RW + 1500;
           ST = Math.floor(RW * Y);
         }
         else {
           if (X < 52152) {
              Y = (X - 12739) / 10000;
              RW = Y * 228.74;
              RW = RW + 2397;
              RW = RW * Y;
              ST = Math.floor(RW + 989);
            }
         else {
           if(X < 250001)
                ST = Math.floor(X * 0.42 - 7914);
             else
                ST = Math.floor(X * 0.45 - 15414);
              }
           }
       }
    ST = ST * KZTAB;
 }
}